library arasu.model;
import "dart:mirrors";
import "dart:convert";
abstract class BigdataModel {
  Map<String,dynamic> attributes;
  
  Map<String,dynamic> get changes {
    Map<String,dynamic> latest = encode();
    Map<String,dynamic> changed = new Map<String,dynamic>();
    latest.keys.forEach((e){ 
      if(latest[e] != attributes[e]) {
        switch (latest[e].runtimeType.toString()) {
          case '_LinkedHashMap':
            if (attributes[e]==null){
              attributes[e] = new Map<String,dynamic>();
            }
            Map<String,dynamic> chg = _diff(attributes[e],latest[e]);
            if (chg!=null){
              changed[e]=chg;
            }
            break;
          // case 'DateTime':
          //   changed[e]=latest[e].toString();
          //   break;
          default:
            changed[e]= latest[e];
        }
      }  
    });
    return changed;
  }  

  Map<String,dynamic> encode(){
    Map<String,dynamic> map = new Map<String,dynamic>();
    InstanceMirror im = reflect(this);
    declarations(im.type).forEach((dm) {
      var key = MirrorSystem.getName(dm.simpleName);
      var val = im.getField(dm.simpleName).reflectee;
      if(val.runtimeType!=Null) { 
        switch (val.runtimeType.toString()){
          case '_LinkedHashMap':
            Map<String,dynamic> orig = (val as Map<String,dynamic>),clon={};
            clon.addAll(orig);
            map[key]=clon;
            break;
          // case 'DateTime':
          //   map[key]=val.toString();
          //   break;
          default:
            map[key] = val; 
        }
      }
    });
    return map;
  }
  
  String encodeWithAttr({String key: 'attr'}) => JSON.encode({key:encode()});
  Iterable<DeclarationMirror> declarations(ClassMirror cm) => 
      cm.declarations.values.where((dm) => 
          dm is VariableMirror && 
          !dm.isConst && 
          !dm.isFinal && 
          !dm.isPrivate && 
          !dm.isStatic && 
          !dm.isTopLevel);

  Map<String,dynamic> _diff(Map<String,dynamic> src,Map<String,dynamic> dst){
    Map<String,dynamic> res={};
    List<String> srcKeys=src.keys.toList();
    List<String> dstKeys=dst.keys.toList();
    List<String> allKeys=new List<String>();
    allKeys.addAll(srcKeys);
    allKeys.addAll(dstKeys);
    allKeys.toSet().forEach((e){
      if (src[e]!=dst[e] && dst[e]!=null)  {
        switch (dst[e].runtimeType.toString()){
          case 'DateTime':
            res[e]=dst[e].toString();
            break;
          default:
            res[e]=dst[e];
        }
      }
    });
    if (res.isEmpty){
      return null;
    }
    return res;
  }
}
